#include "protein2.h"

int DEBUG = 0;
namespace Salign_PARAMS{
// alpha is the normalized factor(as seen in paper); D00 is "D0"; Denv the distance cutoff used to determine the "environment residues"
	double Alpha=0.3, D00=4., Denv=12.;
// score_type decids the type of calculated alignment scores (SP, TM, GDT-scores are supported)
// fragsize is the length of fragment for the original alignment trials during finding the best alignment
	int score_type=iSP, fragsize=20; 
// iprint controls the details to print, the bigger the more printed
	int iprint=-9999;
// bscoreOnly: 0, structure alignment; others, score only (using predefined alignment)
// 1,scored according to resi No.; 2,scored according to residues sequentially
	int bscoreOnly=0;
}
int rdpdb(string fn, char seq1[], double x[][3]){
	FILE *fp = openfile(fn);
	char str[201], an[4], rn[5];
	int nr = 0;
	while(fgets(str, 200, fp) != NULL){
		if(strstr(str, "ATOM") != str) continue;
		sscanf(str+13, "%3s", an); an[2] = '\0';
		if(strcmp(an, "CA") != 0) continue;
		sscanf(str+17, "%3s", rn); rn[3] = '\0';
		int id = aaDefine(rn, 1);
		seq1[nr] = rnam1_std[id];
		str2dat(str+30, 3, x[nr]);
		nr ++;
	}
	seq1[nr] = '\0';
	return nr;
}
int main(int argc, char *argv[]){
	if(argc < 2) die("usage: RUN protein1 protein2");
	int nr1, nr2;
	char seq1[5000], seq2[5000];
	double x1[5000][3], x2[5000][3];
	nr1 = rdpdb(argv[1], seq1, x1);
	nr2 = rdpdb(argv[2], seq2, x2);
	Protein2 *p1 = new Protein2(nr1, seq1, x1);
	Protein2 *p2 = new Protein2(nr2, seq2, x2);
//
	iprint = 100; bscoreOnly = 0;
	Salign *sa1 = new Salign();
	sa1 -> init(p1, p2, 1);
	sa1 -> Run_all();
	sa1 -> print_max(stdout);
	delete p1; delete p2;
	delete sa1;
}
