#include "protein2.h"

int DEBUG = 0;
namespace Salign_PARAMS{
// alpha is the normalized factor(as seen in paper); D00 is "D0"; Denv the distance cutoff used to determine the "environment residues"
	double Alpha=0.3, D00=4., Denv=12.;
// score_type decids the type of calculated alignment scores (SP, TM, GDT-scores are supported)
// fragsize is the length of fragment for the original alignment trials during finding the best alignment
	int score_type=iSP, fragsize=20; 
// iprint controls the details to print, the bigger the more printed
	int iprint=-9999;
// bscoreOnly: 0, structure alignment; others, score only (using predefined alignment)
// 1,scored according to resi No.; 2,scored according to residues sequentially
	int bscoreOnly=0;
}
int main(int argc, char *argv[]){
	if(argc < 2) die("usage: RUN protein1 protein2 [-score1|-score2]");
	iprint = 100;
	Protein2 *p1 = new Protein2(argv[1]);
	Protein2 *p2 = new Protein2(argv[2]);
	if(argc >= 4){
		if(string(argv[3]) == "-score1") bscoreOnly = 1;
		else if(string(argv[3]) == "-score2") bscoreOnly = 2;
	}
	Salign *sa1 = new Salign();
	sa1 -> init(p1, p2, 1);
	sa1 -> Run_all();
	sa1 -> print_max(stdout);
}
